from collections import defaultdict
from lib2to3.fixer_base import BaseFix as lib2to3_BaseFix
import lib2to3.fixer_util


class BaseFix(lib2to3_BaseFix):
  def start_tree(self, tree, filename):
    super(BaseFix, self).start_tree(tree, filename)

    self.ids = defaultdict(int)

  def traced_call(self, name, insert_function, node, children):
    # Important: every node inside "children" should be cloned before this
    # function is called.

    first_child = children[0]
    if node.prefix == first_child.prefix:
      first_child.prefix = ''

    filename = self.filename
    lineno = node.get_lineno()
    id_ = self.ids[lineno]

    new_node = lib2to3.fixer_util.Call(
      lib2to3.fixer_util.Name(name),
      args=[
        lib2to3.fixer_util.String('"%s"' % filename),
        lib2to3.fixer_util.Comma(),
        lib2to3.fixer_util.Number(lineno),
        lib2to3.fixer_util.Comma(),
        lib2to3.fixer_util.Number(id_),
        lib2to3.fixer_util.Comma(),
      ] + children,
      prefix=node.prefix)

    self.ids[lineno] += 1

    insert_function(filename, lineno, id_)

    return new_node
